using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public enum BehaResult {Failure, Success, NodeProblem};

public class Task 
{
	public List<Task> children; 
	public string name;
	public int nbVisit;
	
	public Task()
	{
		children = new List<Task>(); 
		
	}
	public void Count()
	{
		nbVisit +=1;
	}
	public virtual BehaResult run(MonoBehaviour agent)
	{
		Count();	
		return BehaResult.Failure;
	}
	public void Add(Task c)
	{
		children.Add(c);	
	}
	
	public string PrintStats()
	{
		string final;
		final = name;
		final += "- " + ((float)((float)(nbVisit)/
					(float)(GameInfo.Instance.nbInteration))).ToString();
		if(children.Count > 0)
		{
			final +=": (";
			foreach (Task task in children)
			{
				final += task.PrintStats();
				//Do not print a coma at the last children
				if (task != children[children.Count-1])
					final += ", ";
			}
			final += ( ")");
		}
		return final;	
	}
	
	public string Print()
	{
		//Print the tree structure. 
		string final;
		final = name;
		
		if(children.Count > 0)
		{
			final +=": (";
			foreach (Task task in children)
			{
				final += task.Print();
				if (task != children[children.Count-1])
					final += ", ";
			}
			final += ( ")");
		}
		return final;
	}
	
}
