using System.Collections;
using UnityEngine;

public class MoveAwayTask : Task
{
	float radius = 3; 
	
	public MoveAwayTask():base()
	{
		
		this.name = "MoveAwayTask";
		
	}
	public override BehaResult run (MonoBehaviour agent)
	{
				//Stats
		base.run(agent);
		
		Vector3 target = new Vector3(-1000,1000,-1000);
		
		foreach(GameObject o in HeavyInfo.Instance.EnemyShootable)
		{
			//Get the closer Enemy
			EnemyBehaviour b = (EnemyBehaviour)o.GetComponent("EnemyBehaviour"); 
			
			if ( b.alive && (agent.transform.position - b.transform.position).sqrMagnitude <  
				(agent.transform.position - target).sqrMagnitude)
			{
				
				target = b.transform.position;
			}	
			
		}
		
		//Found an enemy
		if(target.z != -1000)
		{ 
			float radius = 10; 
			Vector2 insideCircle2D = Random.insideUnitCircle * radius;
			Vector3 randomInsideCirlce = new Vector3(insideCircle2D.x,insideCircle2D.y,agent.transform.position.z);
				
			randomInsideCirlce = new Vector3();
			randomInsideCirlce.z = 20;
				
			HeavyInfo.Instance.heavyBehaviour.SetTarget((agent.transform.position - target) 
				+ agent.transform.position + randomInsideCirlce);
			
			return BehaResult.Success;
		}
		return BehaResult.Failure;
	}
}


