using System;
using UnityEngine; 

public class ShootEnnemyTask:Task
{
	public ShootEnnemyTask():base()
	{
		this.name = "ShootEnnemyTask";
	}
	
	public override BehaResult run (MonoBehaviour agent)
	{
		//Stats
		base.run(agent);
		
		Vector3 target = new Vector3(-1000,1000,-1000);
		
		foreach(GameObject o in HeavyInfo.Instance.EnemyShootable)
		{
			//Get the closer Enemy
			EnemyBehaviour b = (EnemyBehaviour)o.GetComponent("EnemyBehaviour"); 
			
			if ( b.alive && (agent.transform.position - b.transform.position).sqrMagnitude <  
				(agent.transform.position - target).sqrMagnitude)
			{
				
				target = b.transform.position;
			}	
			
		}
		
		//Found an enemy
		if(target.z != -1000)
		{ 
			HeavyInfo.Instance.heavyBehaviour.Shoot(target);
			
			return BehaResult.Success;
		}
		
		//This will not work as the node before just stopped the heavy
		//Have to make sure everything is well checked before guetting here.
		return BehaResult.Failure;
		
		
	}
}


