using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class EnemyBehaviour : MovingEntity {

	// Use this for initialization
	public List<GameObject> viewPeople = new List<GameObject>(); 
	Sequencer tree;
	public bool eating; 
	
	public bool alive = true; 
	public float Health; 
	public float MaxHealth = 100; 
	
	public float eatingTimer; 
	public float maxEatingTimer = 1.6f; 
	
	//Stats for the project
	public float totalElapseTime = 0.0f;
	
	void Start () 
	{
		tree = new Sequencer(); 
		eating = false; 
		arrive = true; 
		seek = false; 
		eatingTimer = maxEatingTimer;
		Health = MaxHealth;
		
		//For moving do now want effects. 
		rigidbody.constraints = RigidbodyConstraints.FreezePositionY |RigidbodyConstraints.FreezeRotation; 	
	
		tree.children.Add(new SeeSomeone()); 
		tree.children.Add(new MoveToward()); 
		tree.children.Add(new StopWhenTouching()); 
		tree.children.Add(new Eat());
	
	}
	
	// Update is called once per frame
	override public void Update () 
	{
		eatingTimer += Time.deltaTime;
		
		totalElapseTime +=Time.deltaTime; 
		

		if(alive)
		{
			tree.run(this); 
			base.Update();
		}
		/*
		if(HeavyInfo.Instance.EnemyShootable.Contains(this.gameObject))
		{
			renderer.material.color = Color.magenta;
		}
		else
			renderer.material.color = Color.green;
	*/
	}
	


	void OnCollisionEnter(Collision col)
	{
		if(col.collider.tag == "Bullet")
		{	
		 	GameObject g = GameObject.FindGameObjectWithTag("Heavy"); 
			viewPeople.Add(g); 
			Health -= 30; 
			
			if(Health < 0)
			{
				alive = false; 
				GameInfo.Instance.enemiesKilled ++;
				rigidbody.constraints = RigidbodyConstraints.None; 
				Vector3 push = col.transform.position - this.transform.position; 
				push.Normalize(); 
				push *= 500; 
				rigidbody.AddForce(-push);
				rigidbody.AddTorque(push);
			}
		}
		if(col.collider.name == "Heavy" && alive)
		{
			if(col.collider.isTrigger == true)
			{
				//If can shoot change color
				
			}
		}
	}

	
	void OnCollisionStay(Collision col)
	{
		if(col.collider.tag == "Heavy" || col.collider.tag == "Player")
		{
			
			eating = true;
		}		
	}
	void OnCollisionExit(Collision col)
	{
		if(col.collider.tag == "Heavy" || col.collider.tag == "Player")
		{
			
			eating = false;
		}
		
		if(col.collider.name == "Heavy" && col.collider.isTrigger)
		{
			//Come back to green; 
			//renderer.material.color = Color.green;
		}
	}
	void OnTriggerExit (Collider other) 
	{

		if(other.tag == "Player" || other.collider.tag == "Heavy")
		{
			if(!other.isTrigger)
				viewPeople.Remove(other.gameObject);
			
		}
	}
	void OnTriggerEnter(Collider other)
	{
		if(other.collider.tag == "Player" || other.collider.tag == "Heavy")
		{
			if(other.isTrigger == false && !viewPeople.Contains(other.gameObject))
				viewPeople.Add(other.gameObject); 
		}
	}
	void OnTriggerStay (Collider other)
	{


	}
}