using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class HeavyBehaviour : MovingEntity {
	
	public BulletMoving bulletPrefab;
	Task tree; 
	private float timeBetweenShoot = 2f;
	private float timeNow;

	float timerHealing; 
	float timerMaxHealing = 1; 
	
	int bulletShot = 0;
	
	List<float> averageHealth = new List<float>(); 
	
	void Start () 
	{
		seek = false;
		target = transform.position; 
		arrive = false;
		timeNow = timeBetweenShoot+1; 
		HeavyInfo.Instance.heavyBehaviour = this; 
		
		timerHealing = timerMaxHealing;
		
		
		//Tree 1 - With the randomness
		/*
		tree = new Selector();
		Task t = new Sequencer();
		t.Add((Task)new SeeEnemyTask());
		t.Add((Task)new StopTask());
		t.Add((Task)new ShootEnnemyTask());
		
		tree.children.Add((Task)t); 
		tree.children.Add((Task)new MoveRandomTask()); 
		*/
		
		//Tree 2 - Move towards the goal
		/*
		tree = new Selector();
		Task t = new Sequencer();
		t.Add((Task)new SeeEnemyTask());
		t.Add((Task)new StopTask());
		t.Add((Task)new ShootEnnemyTask());
		
		tree.children.Add((Task)t); 
		tree.children.Add((Task)new MoveTowardsGoalTask()); 
		*/
		
		
		//Tree 3 - Move away zombie and then move towards the goal
		tree = new Selector();
		Task t = new Sequencer();
		t.Add((Task)new SeeEnemyTask());
		Task t2 = new Selector();
		t2.Add((Task)new MoveAwayTask());
		Task t3 = new Sequencer();
		t3.Add((Task)new StopTask());
		t3.Add((Task)new ShootEnnemyTask());
		t2.Add(t3);
		t.Add(t2);
		tree.children.Add((Task)t); 
		tree.children.Add((Task)new MoveTowardsGoalTask()); 
		
		
		print (tree.Print());
	}
	
	// Update is called once per frame
	override public void Update () 
	{
		timeNow += Time.deltaTime; 
		timerHealing +=Time.deltaTime;
		
		
		tree.run(this);
		
		//Keep track of the average health
		averageHealth.Add(GameInfo.Instance.heavyHealt); 
		
		//Stop the game if die
		if(GameInfo.Instance.heavyHealt < 0)
		{
			print ("The game is lost!");
			Application.Quit();
		}
		
		base.Update(); 
		
		/*GameObject a = GameObject.FindGameObjectWithTag("HealBeam");
		
		if(a.renderer.enabled)
		{
			timerHealing += Time.deltaTime;
			if(timerHealing > timerMaxHealing)
			{
				timerHealing = 0; 
				GameInfo.Instance.heavyHealt += 1; 
				if(GameInfo.Instance.heavyHealt > GameInfo.Instance.MaxHealtHeavy)
					GameInfo.Instance.heavyHealt = GameInfo.Instance.MaxHealtHeavy;
			}
		}
		*/
	}
	void OnDestroy()
	{
		//Print the stats when the 
		print(tree.PrintStats());
		print("Time in Total: " + GameInfo.Instance.timeElapse.ToString());
		print("Bullets shot: " + bulletShot.ToString());
		
		float av = 0; 
		
		foreach(float i in averageHealth)
		{ 
			av += i;	
		}
		print("Number of enemies killed: " + GameInfo.Instance.enemiesKilled.ToString());	
		print("Average Health: " + (av/averageHealth.Count).ToString());
	
	}
	
	public void Shoot(Vector3 destination)
	{
		if(timeNow<timeBetweenShoot)
			return;
		
		timeNow = 0;
		Vector3 t = destination - transform.position; 
		t.Normalize(); 
		BulletMoving b = (BulletMoving)Instantiate(bulletPrefab, transform.position + t*1.5f, Quaternion.identity);
		b.shooter = this.gameObject;
		b.SetTarget(destination);
		b.Velocity = t*b.maxSpeed;
		b.Force = t*b.maxForce;
		GameInfo.Instance.bullets.Add(b);
		timeNow = 0; 
		
		//Keep a number of bullet
		bulletShot ++;
	}
	
	
	//COLLISIONS
	void OnTriggerEnter (Collider other)
	{

	}
	void OnTriggerStay(Collider other)
	{
		if(other.tag == "Enemy" && !other.isTrigger)
		{
			if(!HeavyInfo.Instance.EnemyShootable.Contains(other.gameObject))
			{
				HeavyInfo.Instance.EnemyShootable.Add(other.gameObject); 
			}
		} 
		
	}
	void OnTriggerExit(Collider other)
	{
		if(other.tag == "Enemy")
		{
			
			HeavyInfo.Instance.EnemyShootable.Remove(other.gameObject); 
			
		} 	
	}
	
	void OnCollisionEnter(Collision col)
	{
		//Collide with the goal 
		//have to kill the game and look at the stats
		if(col.collider.name == "Item")
		{
			//transform.localScale = transform.localScale * 2;
			//Stop the game, it wins
			print("You have won the game");
			Destroy(this);
			Application.Quit();
			
			Destroy(col.collider.gameObject);
		}
	}

	
	
}
