using UnityEngine;
using System.Collections;
using System;
public class MovingEntity : MonoBehaviour {

	public float mass =1;
	public float maxSpeed =1; 
	public float maxForce =1; 
	
	public double slowfactor = 10; 
	
	public Vector3 target;
	public bool arrive = true; 
	public bool seek = false; 
	
	protected Vector3 force; 
	protected Vector3 heading;
	protected Vector3 velocity; 

	public virtual void Update () 
	{
		CalculateForce(); 
		double temp; 
		
		//Bring the force back to max
		if(force.magnitude> maxForce)
		{	
			force.Normalize(); 
			force*=maxForce; 
		}
		Vector3 acceleration = force / mass;
		
		velocity += acceleration * Time.deltaTime * 2; 
		
		//Bring the max velocity back to normal
		if(velocity.magnitude>maxSpeed)
		{
			temp = velocity.magnitude; 
			temp = maxSpeed/temp; 
			velocity *= (float)temp; 
		}
		//Moving
		
		velocity += velocity*Time.deltaTime*2; 
		
		//This code is for the player moves, slow down the speed when no force.
		if(force == Vector3.zero && seek == false)
		{
            Vector3 temp2 = velocity;
            temp2.Normalize();
            velocity -= (temp2 * (float)(1f/slowfactor));
			 
		}
		
		//Make sure it spots before just moving a little bit
		if(velocity.magnitude > 0.01)
		{
			heading = velocity; 
			heading.Normalize(); 
		}
		else
		{
			velocity = Vector3.zero;
			rigidbody.velocity = Vector3.zero; 
			heading = Vector3.zero; 
		}
		
		//Stop a little before the target
		Vector3 toTarget = target - transform.position;
		float distance = toTarget.magnitude; 
		
		
		if(velocity.magnitude<0.1 && distance < 2) 
		{
			
			arrive = true; 	
		}
		else
			arrive = false; 
		
		rigidbody.velocity = this.velocity; 
		//Dont forget to bring the forces back to zero bitch!
		force = Vector3.zero;
	}
	
	virtual public void SetTarget(Vector3 target)
	{
		this.target = target; 
		arrive = false; 
		seek = true; 
	}
	
	public void Stop()
	{
		target = this.transform.position;
		rigidbody.velocity = Vector3.zero;
		velocity = Vector3.zero;
		arrive = true;
		seek = false; 
	}
	
	
	public Vector3 Arrive()
	{
		Vector3 toTarget = target - transform.position;
		double distance = toTarget.magnitude;
		Vector3 forceReturn = new Vector3();
		
		if (distance > 0 && seek)
		{	
			double Speed = distance/slowfactor ;
			Speed = Math.Min(Speed,maxSpeed); 
			
			Vector3 desiredVelocity = toTarget * (float)Speed / (float)distance; 
			forceReturn += desiredVelocity - velocity; 
		}
		
		return forceReturn;
	}
	
	public void CalculateForce()
	{
		force += Arrive(); 
		
	}

	public Vector3 Heading 
	{
		get 
		{
			return this.heading;
		}
	}

	public Vector3 Force 
	{
		get 
		{
			return this.force;
		}
		set 
		{
			force = value;
		}
	}
	
	public Vector3 Velocity 
	{
		get 
		{
			return this.velocity;
		}
		set
		{
			this.velocity = value; 	
		}
	}
}

